## Management and Execution of Actions

This section describes the main features of the Actions module for executing commands, procedures, and tasks, as well as their scope by defining the context.

- **Action:**
A general operation that can be requested from the web administration console and will be executed on clients.
- **Command**
Predefined action in the OpenGnsys web console. In this new OpenGnsys console, new commands can be added using the "script" function of the procedures.
- **Procedure** (Script)
Sequence of actions with their execution parameters that can be launched to be executed on any client or group of clients. This feature is articulated through "Scripts".
- **Task**
Sequence of actions, similar to the procedure, performed directly on a determined execution scope that can be scheduled for specific time periods.

To access these features, we have three options that determine their scope:

- **From the side panel**, where we can work directly with **Commands** and **Tasks** to **Create**, **Edit**, **Delete**.
- **From the group tree** where we have access to the "Run Script" menu, allowing us to perform this action on the objects contained in this group.
- **On a specific client**, where we can access both the predefined actions menu and the script menu.

![oggui-acciones_menus.png](../../assets/images/screenshots/oggui-acciones_menus.png){ style="display: block; margin: 20px auto; max-width: min(1024px, 100%); height: auto;" }

!!! warning "Warning"
    The new console allows, despite having selected a group in the group tree, reviewing the selection to make it more granular, removing from the target client list those on which the activity is not to be carried out. The "Command Execution" button is enabled when at least one client is selected.

![oggui-acciones_seleccion.png](../../assets/images/screenshots/oggui-acciones_seleccion.png){ style="display: block; margin: 20px auto; max-width: min(1024px, 100%); height: auto;" }

## Predefined Actions

From the client window, we can access the available actions for a specific client, depending on its state.

In the example, we observe that the client is on, therefore the available actions are:

![oggui-acciones_menu_cliente.png](../../assets/images/screenshots/oggui-acciones_menu_cliente.png){ style="float: right; margin: 0 0 15px 20px; max-width: min(350px, 45%); height: auto;" }

- **Shutdown**: allows shutting down a powered-on device. In this specific case, the client icon being yellow indicates that it is logged into ogLive.
- **Restart**
- **Start Session**
- **Create Image**: being logged into ogLive allows us to create an image from this device if we consider it the model device.
- **Clone/deploy image**: cloning and image deployment tools are available if we are on a device logged into ogLive.
- Delete Cache Image
- **Partition and Format**: the cloning engine is available, allowing us to work with the disk structure.
- Software Inventory
- Hardware Inventory
- **Run script**: likewise, we are allowed to run scripts on the client, which in this case, are limited to the ogLive application scope.

<div style="clear: both;"></div>
